file_helper = {}

function file_helper.writeFile(FileName, Contents)
   local File = io.open( FileName, 'w')
   File:write(Contents)
   File:close()
end

function file_helper.readFile(FileName)
   local File = io.open(FileName, 'r')
   local Contents = File:read('*a')
   File:close()
   return Contents
end

function file_helper.readFileOrDefault(FileName, DefaultContent)
   Success, Result = pcall(file_helper.readFile, FileName)
   if Success then
      return Result
   end
   return DefaultContent
end

function file_helper.writeFileIfChanged(FileName, Contents)
   local ContentsOrig = file_helper.readFileOrDefault(FileName, nil)
   if Contents ~= ContentsOrig then
      file_helper.writeFile(FileName,Contents)
   end
end

-- a hack meant as an alternative to a function that checks if a file exists
-- try opening it for reading, and if that succeeds, we can assume it exists
function file_helper.fileIsReadable(FileName)
   local Success, Handle, Message = pcall(io.open, FileName, 'r')
   local Result = Success and (Handle~=nil)
   if Handle then Handle:close() end
   return Result
end

function file_helper.fileSize(FileName)
   Content = file_helper.readFileOrDefault(FileName)
   if not Content then
      return nil
   end
   return #Content
end
